<template>
    <div class="custom-card">
        <h2>Favourites Cities</h2>
        <div v-if="get('favourites').length">
            <ul class="cities">
                <li v-for="city in get('favourites')"
                    @click="getWeatherData({q: city})"
                    :key="city"
                    class="city">
                    {{ city }}
                    <img class="icon delete ml-3"
                         src="../../assets/close.png"
                         @click.stop="remove(city)"/>
                </li>
            </ul>
        </div>
        <div v-else>There are no favourite cities</div>
        <div v-if="weather">
            <g-map :coord="weather.coord" />
            <weather :weather="weather" />
        </div>
    </div>
</template>

<script>
    import { mapGetters } from 'vuex'
    import weather from '../../mixins/weather'
    import Weather from '../dashboard/Weather'
    import GMap from '../helpers/GMap'

    export default {
        name: "Favourites",
        components: {
            Weather, GMap
        },
        mixins: [weather],
        data() {
            return {
                weather: null,
                google: null
            }
        },
        computed: {
            ...mapGetters([
                'get'
            ])
        },
        methods: {
            remove(city) {
                const index = this.get('favourites').indexOf(city);
                this.$store.commit('removeFavourite', index);
                localStorage.setItem('favourites', JSON.stringify(this.get('favourites')));
            },
            getWeatherData(params) {
                this.getWeather(params)
                    .then(data => {
                        this.weather = data;
                        this.weather.format = JSON.parse(JSON.stringify(this.get('format')));
                    })
                    .catch(err => console.dir(err));
            },
        }
    }
</script>

<style scoped lang="scss">
    .cities {
        display: flex;
        align-items: center;
        flex-wrap: wrap;
    }

    .city {
        cursor: pointer;
        display: flex;
        align-items: center;
        background-color: #28a745;
        color: white;
        padding: .1rem .5rem;
        margin: 0 .5rem .5rem 0;
        border-radius: 3px;
    }

    .delete {
        width: .7rem;
        height: .7rem;
    }
</style>